﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;

namespace TestProject
{
    /// <summary>
    /// 레시피
    /// </summary>
    public class Recipe
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 번호 - Number

        /// <summary>
        /// 번호
        /// </summary>
        public int Number { get; set; }

        #endregion
        #region 명칭 - Name

        /// <summary>
        /// 명칭
        /// </summary>
        public string Name { get; set; }

        #endregion
        #region 색상 - Color

        /// <summary>
        /// 색상
        /// </summary>
        public string Color { get; set; }

        #endregion
        #region 재료 리스트 - IngrdientList

        /// <summary>
        /// 재료 리스트
        /// </summary>
        public List<string> IngrdientList { get; set; }

        #endregion
        #region 재료 리스트 - Ingredients

        /// <summary>
        /// 재료 리스트
        /// </summary>
        public string Ingredients { get; set; }

        #endregion
        #region 재료 수 - IngredientCount

        /// <summary>
        /// 재료 수
        /// </summary>
        public int IngredientCount
        {
            get 
            {
                return IngrdientList.Count();
            }
        }

        #endregion


        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 재료 임의로 추가하기 - RandomizeIngredients()

        /// <summary>
        /// 재료 임의로 추가하기
        /// </summary>
        public void RandomizeIngredients()
        {
            Random numberRandom     = new Random();
            Random ingredientRandom = new Random();

            ObservableCollection<string> collection = new ObservableCollection<string>
            {
                "Garlic",
                "Lemon",
                "Butter",
                "Lime",
                "Feta Cheese",
                "Parmesan Cheese",
                "Breadcrumbs"
            };

            for(int i = 0; i < numberRandom.Next(0, 4); i++)
            {
                string newIngredient = collection[ingredientRandom.Next(0, 6)];

                if(!IngrdientList.Contains(newIngredient))
                {
                    Ingredients += "\n" + newIngredient;

                    IngrdientList.Add(newIngredient);
                }
            }
        }

        #endregion
    }
}